import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core.dart';

/// This is thrown when a an `M4eServerException` occures
class M4eServerException extends Equatable implements Exception {
  final M4eExceptionCode code;
  final String message;

  const M4eServerException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[M4eServerException] code: ${code.toString()}, message:$message';
  }
}

/// This is thrown when a an `M4eCacheException` occures
class M4eCacheException extends Equatable implements Exception {
  final M4eExceptionCode code;
  final String message;

  const M4eCacheException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[M4eCacheException] code: ${code.toString()}, message:$message';
  }
}

/// This is thrown when `M4eAuthException` occures
class M4eAuthException extends Equatable implements Exception {
  final M4eExceptionCode code;
  final String message;

  const M4eAuthException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[M4eAuthException] code: ${code.toString()}, message:$message';
  }
}
