import 'package:equatable/equatable.dart';
import 'package:flutter/cupertino.dart';

/// Form parameters required for m4e-sdk
/// authentication OTP verification
///
class M4eAuthOTPVerificationForm extends Equatable {
  final String otpCode;

  const M4eAuthOTPVerificationForm._(this.otpCode);

  factory M4eAuthOTPVerificationForm({@required String otpCode}) {
    assert(
        otpCode != null, 'M4eAuthPhoneNumberForm [otpCode] should not be null');

    return M4eAuthOTPVerificationForm._(otpCode);
  }

  @override
  List<Object> get props => [otpCode];

  @override
  String toString() => 'M4eAuthOTPVerificationForm(otpCode: $otpCode)';
}
