import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4eWalletForm extends Equatable {
  final M4eUniqueId id;
  final String label;
  final M4eCurrencyType currency;
  final M4eWalletType type;

  const M4eWalletForm._(this.id, this.label, this.currency, this.type);

  factory M4eWalletForm({
    @required String label,
    @required M4eCurrencyType currency,
    M4eWalletType type,
  }) {
    assert(label != null, 'M4eWalletForm [label] should not be null');
    assert(currency != null, 'M4eWalletForm [currency] should not be null');

    return M4eWalletForm._(
        M4eUniqueId(), label, currency, type ?? M4eWalletType.bascule);
  }

  Map<String, dynamic> toJson() {
    return {
      'label': this.label,
      'currency': this.currency.toString(),
      'type': this.type.toString(),
    };
  }

  @override
  List<Object> get props => [id, label, currency, type];

  @override
  String toString() {
    return 'M4eWalletForm(id: $id, label: $label, currency: ${currency.toString()}, type: ${type.toString()})';
  }
}
