import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

class M4eAmount extends Equatable {
  final double value;
  final String currency;

  const M4eAmount._(this.value, this.currency);

  factory M4eAmount({@required double value, @required String currency}) {
    assert(value != null, 'M4eAmount [value] should not be null');
    assert(currency != null, 'M4eAmount [currency] should not be null');
    return M4eAmount._(value, currency);
  }

  factory M4eAmount.fromJson(Map<String, dynamic> json) {
    return M4eAmount(
      value: json['value'],
      currency: json['unit'],
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'value': this.value,
      'unit': this.currency,
    };
  }

  @override
  List<Object> get props => [
        value,
        currency,
      ];

  @override
  String toString() => 'M4eAmount(value: $value, currency: $currency)';
}
