import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core/core.dart';

class M4eAuthToken extends Equatable {
  final M4eUniqueId id;
  final String token;

  const M4eAuthToken._(this.id, this.token);

  factory M4eAuthToken({@required M4eUniqueId id, @required String token}) {
    assert(id != null, 'M4eAuthToken [id] should not be null');
    assert(token != null, 'M4eAuthToken [token] should not be null');
    return M4eAuthToken._(id, token);
  }

  factory M4eAuthToken.fromJson(Map<String, dynamic> json) {
    final _data = json['data'];

    return M4eAuthToken(
      id: M4eUniqueId.fromUniqueString(_data['id']),
      token: _data['token'],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'data': {
        'id': this.id.value.toString(),
        'token': this.token,
      }
    };
  }

  @override
  List<Object> get props => [id, token];

  @override
  String toString() => 'M4eAuthToken(id: $id, token: $token)';
}
