import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

class M4ePhoneNumber extends Equatable {
  final String number;
  final String country;

  const M4ePhoneNumber._(this.number, this.country);

  factory M4ePhoneNumber({@required String number, @required String country}) {
    assert(country != null, 'PhoneNumber [country] should not be null');
    assert(number != null, 'PhoneNumber [number] should not be null');
    return M4ePhoneNumber._(number, country);
  }

  factory M4ePhoneNumber.fromJson(Map<String, dynamic> json) {
    return M4ePhoneNumber(
      country: json['country'],
      number: json['number'],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'country': this.country,
      'number': this.number,
    };
  }

  @override
  List<Object> get props => [number, country];

  @override
  String toString() => 'M4ePhoneNumber(number: $number, country: $country)';
}
