import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core/core.dart';
import 'models.dart';

class M4eUser extends Equatable {
  final M4eUniqueId id;
  final String shortName;
  final String firstName;
  final String lastName;
  final M4ePhoneNumber phoneNumber;
  final DateTime joined;

  const M4eUser({
    @required this.id,
    @required this.shortName,
    @required this.firstName,
    @required this.lastName,
    @required this.phoneNumber,
    @required this.joined,
  });

  factory M4eUser.fromJson(Map<String, dynamic> json) {
    return M4eUser(
      id: M4eUniqueId.fromUniqueString(json['id']),
      shortName: json['shortName'],
      firstName: json['firstName'],
      lastName: json['lastName'],
      phoneNumber: M4ePhoneNumber.fromJson(json['phone']),
      joined: DateTimeConverter.fromTimestampSinceEpoch(json['joined']),
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'user': {
        'shortName': this.shortName,
        'firstName': this.firstName,
        'lastName': this.lastName,
        'phone': this.phoneNumber.toJson(),
        'joined': this.joined.toTimestampSinceEpoch(),
      },
    };
  }

  @override
  List<Object> get props =>
      [id, shortName, firstName, lastName, phoneNumber, joined];

  @override
  String toString() {
    return 'M4eUser(id: $id, shortName: $shortName, firstName: $firstName, lastName: $lastName, phoneNumber: $phoneNumber, joined: $joined)';
  }
}
