import 'package:flutter_test/flutter_test.dart';
import 'package:m4e_sdk/src/core/core.dart';
import 'package:m4e_sdk/src/data/services/services.dart';
import 'package:m4e_sdk/src/m4e_sdk_initialize.dart';

void main() {
  setUpAll(() {
    initializeM4eSDK(
      config: M4eSDKConfig.development(
          appId: 'b834b997-64ed-4a19-b8fa-de14d6b005b6'),
    );
  });

  group('M4eAuthService Test | ', () {
    test('Constructing Auth should find correct dependencies', () {
      final _authService = M4eAuthService();
      expect(_authService != null, true);
    });
  });

  group('M4eTransactionService Test | ', () {
    test('Constructing transaction should find correct dependencies', () {
      final _transactionService = M4eTransactionService();
      expect(_transactionService != null, true);
    });
  });

  group('M4eWalletService Test | ', () {
    test('Constructing Wallet should find correct dependencies', () {
      final _walletService = M4eWalletService();
      expect(_walletService != null, true);
    });
  });

  group('M4eUserService Test | ', () {
    test('Constructing UserService should find correct dependencies', () {
      final _userService = M4eUserService();
      expect(_userService != null, true);
    });
  });
}
